; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "Open with CMD"
!define PRODUCT_VERSION "1.0"
!define PRODUCT_PUBLISHER "Raymel Francisco"
!define PRODUCT_WEB_SITE "https://github.com/raymelon/open-with-cmd"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\open-with-cmd.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "res\terminal.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!insertmacro MUI_PAGE_LICENSE "LICENSE.txt"
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_RUN "$INSTDIR\open-with-cmd.exe"
!define MUI_FINISHPAGE_SHOWREADME "https://github.com/raymelon/open-with-cmd/blob/master/README.md"
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "open-with-cmd-1.0-setup.exe"
InstallDir "$PROGRAMFILES\Open with CMD"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

Section "MainSection" SEC01
  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer
  File "bin\open-with-cmd.exe"
  CreateDirectory "$SMPROGRAMS\Open with CMD"
  CreateShortCut "$SMPROGRAMS\Open with CMD\Open with CMD.lnk" "$INSTDIR\open-with-cmd.exe"
  CreateShortCut "$DESKTOP\Open with CMD.lnk" "$INSTDIR\open-with-cmd.exe"
  File "res\terminal.ico"
  File "LICENSE.txt"
  FILE "res\icon-license.txt"

  WriteRegStr HKCR "*\shell\Open with command prompt" "" "Open with command prompt"
  WriteRegExpandStr HKCR "*\shell\Open with command prompt" "Icon" "$INSTDIR\terminal.ico"
  WriteRegStr HKCR "*\shell\Open with command prompt\command" "" "$INSTDIR\open-with-cmd.exe %1"
  
  File "bin\add-to-context-menu.bat"
SectionEnd

Section -AdditionalIcons
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateShortCut "$SMPROGRAMS\Open with CMD\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\Open with CMD\Uninstall.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninstall-open-with-cmd.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\open-with-cmd.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\open-with-cmd.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd

Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "Open with CMD uninstallation success."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Do you really want to uninstall Open with CMD?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninstall-open-with-cmd.exe"
  Delete "$INSTDIR\add-to-context-menu.bat"
  Delete "$INSTDIR\open-with-cmd.exe"
  Delete "$INSTDIR\terminal.ico"
  Delete "$INSTDIR\LICENSE.txt"
  Delete "$INSTDIR\icon-license.txt"

  Delete "$SMPROGRAMS\Open with CMD\Uninstall.lnk"
  Delete "$SMPROGRAMS\Open with CMD\Website.lnk"
  Delete "$DESKTOP\Open with CMD.lnk"
  Delete "$SMPROGRAMS\Open with CMD\Open with CMD.lnk"

  RMDir "$SMPROGRAMS\Open with CMD"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  DeleteRegKey HKCR "*\shell\Open with command prompt"
  SetAutoClose true
SectionEnd